<html>
<head>
<title>OgreGLDefaultHardwareBufferManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLDefaultHardwareBufferManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLDefaultHardwareBufferManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __GLDefaultHardwareBufferManager_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __GLDefaultHardwareBufferManager_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareBufferManager_8h.html">OgreHardwareBufferManager.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareIndexBuffer_8h.html">OgreHardwareIndexBuffer.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00040"></a><a class="code" href="classOgre_1_1GLDefaultHardwareVertexBuffer.html">00040</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLDefaultHardwareVertexBuffer.html" title="Specialisation of HardwareVertexBuffer for emulation.">GLDefaultHardwareVertexBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a> 
<a name="l00041"></a>00041     {
<a name="l00042"></a>00042     <span class="keyword">protected</span>:
<a name="l00043"></a><a class="code" href="classOgre_1_1GLDefaultHardwareVertexBuffer.html#ad1d007e3585001b3ec357f4888e5903d">00043</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>* <a class="code" href="classOgre_1_1GLDefaultHardwareVertexBuffer.html#ad1d007e3585001b3ec357f4888e5903d">mData</a>;
<a name="l00045"></a>00045         <span class="keywordtype">void</span>* lockImpl(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00047"></a>00047         <span class="keywordtype">void</span> unlockImpl(<span class="keywordtype">void</span>);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049     <span class="keyword">public</span>:
<a name="l00050"></a>00050         <a class="code" href="classOgre_1_1GLDefaultHardwareVertexBuffer.html" title="Specialisation of HardwareVertexBuffer for emulation.">GLDefaultHardwareVertexBuffer</a>(<span class="keywordtype">size_t</span> vertexSize, <span class="keywordtype">size_t</span> numVertices, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage);
<a name="l00051"></a>00051         <a class="code" href="classOgre_1_1GLDefaultHardwareVertexBuffer.html" title="Specialisation of HardwareVertexBuffer for emulation.">GLDefaultHardwareVertexBuffer</a>(<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>* mgr, <span class="keywordtype">size_t</span> vertexSize, <span class="keywordtype">size_t</span> numVertices, 
<a name="l00052"></a>00052             <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage);
<a name="l00053"></a>00053         ~<a class="code" href="classOgre_1_1GLDefaultHardwareVertexBuffer.html" title="Specialisation of HardwareVertexBuffer for emulation.">GLDefaultHardwareVertexBuffer</a>();
<a name="l00055"></a>00055         <span class="keywordtype">void</span> readData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">void</span>* pDest);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058         <span class="keywordtype">void</span> writeData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keyword">const</span> <span class="keywordtype">void</span>* pSource,
<a name="l00059"></a>00059                 <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>);
<a name="l00061"></a>00061         <span class="keywordtype">void</span>* lock(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00063"></a>00063         <span class="keywordtype">void</span> unlock(<span class="keywordtype">void</span>);
<a name="l00064"></a>00064 
<a name="l00065"></a>00065         <span class="comment">//void* getDataPtr(void) const { return (void*)mData; }</span>
<a name="l00066"></a><a class="code" href="classOgre_1_1GLDefaultHardwareVertexBuffer.html#a58c80c0595fc57a8158d2a955fa4d9c8">00066</a>         <span class="keywordtype">void</span>* <a class="code" href="classOgre_1_1GLDefaultHardwareVertexBuffer.html#a58c80c0595fc57a8158d2a955fa4d9c8">getDataPtr</a>(<span class="keywordtype">size_t</span> offset)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<span class="keywordtype">void</span>*)(mData + offset); }
<a name="l00067"></a>00067     };
<a name="l00068"></a>00068 
<a name="l00070"></a><a class="code" href="classOgre_1_1GLDefaultHardwareIndexBuffer.html">00070</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLDefaultHardwareIndexBuffer.html" title="Specialisation of HardwareIndexBuffer for emulation.">GLDefaultHardwareIndexBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>
<a name="l00071"></a>00071     {
<a name="l00072"></a>00072     <span class="keyword">protected</span>:
<a name="l00073"></a><a class="code" href="classOgre_1_1GLDefaultHardwareIndexBuffer.html#af3206b375b8da8bfee18bd03953b05a7">00073</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>* <a class="code" href="classOgre_1_1GLDefaultHardwareIndexBuffer.html#af3206b375b8da8bfee18bd03953b05a7">mData</a>;
<a name="l00075"></a>00075         <span class="keywordtype">void</span>* lockImpl(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00077"></a>00077         <span class="keywordtype">void</span> unlockImpl(<span class="keywordtype">void</span>);
<a name="l00078"></a>00078     <span class="keyword">public</span>:
<a name="l00079"></a>00079         <a class="code" href="classOgre_1_1GLDefaultHardwareIndexBuffer.html" title="Specialisation of HardwareIndexBuffer for emulation.">GLDefaultHardwareIndexBuffer</a>(<a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">IndexType</a> idxType, <span class="keywordtype">size_t</span> numIndexes, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage);
<a name="l00080"></a>00080         ~<a class="code" href="classOgre_1_1GLDefaultHardwareIndexBuffer.html" title="Specialisation of HardwareIndexBuffer for emulation.">GLDefaultHardwareIndexBuffer</a>();
<a name="l00082"></a>00082         <span class="keywordtype">void</span> readData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">void</span>* pDest);
<a name="l00084"></a>00084         <span class="keywordtype">void</span> writeData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keyword">const</span> <span class="keywordtype">void</span>* pSource,
<a name="l00085"></a>00085                 <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>);
<a name="l00087"></a>00087         <span class="keywordtype">void</span>* lock(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00089"></a>00089         <span class="keywordtype">void</span> unlock(<span class="keywordtype">void</span>);
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classOgre_1_1GLDefaultHardwareIndexBuffer.html#a9231b19033d1f4f28d783525dc4eb8d1">00091</a>         <span class="keywordtype">void</span>* <a class="code" href="classOgre_1_1GLDefaultHardwareIndexBuffer.html#a9231b19033d1f4f28d783525dc4eb8d1">getDataPtr</a>(<span class="keywordtype">size_t</span> offset)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<span class="keywordtype">void</span>*)(mData + offset); }
<a name="l00092"></a>00092     };
<a name="l00093"></a>00093 
<a name="l00101"></a><a class="code" href="classOgre_1_1GLDefaultHardwareBufferManagerBase.html">00101</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLDefaultHardwareBufferManagerBase.html" title="Specialisation of HardwareBufferManager to emulate hardware buffers.">GLDefaultHardwareBufferManagerBase</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>
<a name="l00102"></a>00102     {
<a name="l00103"></a>00103     <span class="keyword">public</span>:
<a name="l00104"></a>00104         <a class="code" href="classOgre_1_1GLDefaultHardwareBufferManagerBase.html" title="Specialisation of HardwareBufferManager to emulate hardware buffers.">GLDefaultHardwareBufferManagerBase</a>();
<a name="l00105"></a>00105         ~<a class="code" href="classOgre_1_1GLDefaultHardwareBufferManagerBase.html" title="Specialisation of HardwareBufferManager to emulate hardware buffers.">GLDefaultHardwareBufferManagerBase</a>();
<a name="l00107"></a>00107         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> 
<a name="l00108"></a>00108             createVertexBuffer(<span class="keywordtype">size_t</span> vertexSize, <span class="keywordtype">size_t</span> numVerts, 
<a name="l00109"></a>00109                 <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useShadowBuffer = <span class="keyword">false</span>);
<a name="l00111"></a>00111         <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> 
<a name="l00112"></a>00112             createIndexBuffer(<a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a> itype, <span class="keywordtype">size_t</span> numIndexes, 
<a name="l00113"></a>00113                 <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useShadowBuffer = <span class="keyword">false</span>);
<a name="l00115"></a>00115         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">RenderToVertexBufferSharedPtr</a> createRenderToVertexBuffer();
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     };
<a name="l00118"></a>00118 
<a name="l00120"></a><a class="code" href="classOgre_1_1GLDefaultHardwareBufferManager.html">00120</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLDefaultHardwareBufferManager.html" title="GLDefaultHardwareBufferManagerBase as a Singleton.">GLDefaultHardwareBufferManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a>
<a name="l00121"></a>00121     {
<a name="l00122"></a>00122     <span class="keyword">public</span>:
<a name="l00123"></a><a class="code" href="classOgre_1_1GLDefaultHardwareBufferManager.html#a0142bc7278c645bc0f3f50a70617e155">00123</a>         <a class="code" href="classOgre_1_1GLDefaultHardwareBufferManager.html" title="GLDefaultHardwareBufferManagerBase as a Singleton.">GLDefaultHardwareBufferManager</a>()
<a name="l00124"></a>00124             : <a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a>(<a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1GLDefaultHardwareBufferManagerBase.html" title="Specialisation of HardwareBufferManager to emulate hardware buffers.">GLDefaultHardwareBufferManagerBase</a>()) 
<a name="l00125"></a>00125         {
<a name="l00126"></a>00126 
<a name="l00127"></a>00127         }
<a name="l00128"></a><a class="code" href="classOgre_1_1GLDefaultHardwareBufferManager.html#ac7df714630cb86d601854a29e76be9a4">00128</a>         ~<a class="code" href="classOgre_1_1GLDefaultHardwareBufferManager.html" title="GLDefaultHardwareBufferManagerBase as a Singleton.">GLDefaultHardwareBufferManager</a>()
<a name="l00129"></a>00129         {
<a name="l00130"></a>00130             <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> mImpl;
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132     };
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
